Subject: Re: bug#64046: 30.0.50; Quoting in customize choice tags

From: Stephen Berman <[email-masked]>
Date: Fri, 25 Aug 2023 23:50:00 +0200

On Fri, 25 Aug 2023 10:02:35 +0200 Ola x Nilsson <[email-masked]> wrote:

> On Thu, Aug 24 2023, Mauro Aranda wrote:
>
>> Stephen Berman <[email-masked]> writes:
>>
>>> On Thu, 24 Aug 2023 17:14:53 -0300 Mauro Aranda
>>   <[email-masked]> wrote:
[...]
>>>> Thinking about it, why do we need to call substitute-command-keys on the
>>>> VALUE part (i.e., the cdr of the cons cell), in case of simple item
>>>> definitions?
>>>>
>>>> I re-read the bug report, but I didn't find any reference to why that is
>>>> a need.  Did I miss something?
>>>
>>> Well, the VALUE is displayed on entering a choice.  That is, when I do
>>>
>>> M-: (widget-choose "Title" '(("Use `a'" . "Use `1'") ("Use `b'"
>>   . "Use `2'")))
>>>
>>> I see curve-quoting in the widget-choose buffer:
>>>
>>>    Available choices:
>>>
>>>    0 = Use ‘a’
>>>    1 = Use ‘b’
>>>
>>>    C-g = Quit
>>>
>>> and when I enter e.g. `0' at the "Title: " prompt in the minibuffer, it
>>> displays "Use ‘1’", i.e., with curve-quoting.  But if I omit the call to
>>> substitute-command-keys on the cdr in widget-choose, then typing `0' at
>>> the "Title: " prompt displays "Use `1'", i.e. with grave-quoting.  But I
>>> don't know which one is the intended result.
>>
>> I see, thank you.  Your last patch looks good to me, then.
>
> The cdr is the return value, I would expect widget-choose to not
> modify that. 

I think this is indeed the correct expectation and I should have
recognized it instead of looking only at appearances.  But do you agree
that applying (at least) quote substitution to the car of the simple
item definition is appropriate here?  If so, there is still the question
of whether to use substitute-command-keys or just substitute-quotes.
I'm inclined to stick with the former but would be fine with going with
the latter.

Steve Berman